# Readme

This demo shows how to write a Virtual Server to handle client/backend/event/task/economy invoking in Golang.

## How to access Virtual Server?

### Game client side

You can call InvokeVirtualServer in PGOS SDK to access the specific interface of Virtual Server.

For example:

```c++
// invoke /client_hello
InvokeVirtualServer("vs-sample-go", "/client_hello", "I am request body")
```

### Backend side

You can fire a request to the Virtual Server directly by backend HTTP API

For example:

```bash
curl
-H "content-type: application/json" \
-H "TitleId: your_title_id" \
-H "TitleRegionId: your_titleregion_id" \
-H "SecretId: your_secret_id" \
-H "ServerTicket: your_server_ticket" \
-X POST -d "I am request body" -v http://your_titleregion_domain/backend_hello
```

NOTE: the SecretId is the first part of your Server Key, the ServerTicket is a ticket which is calculated by [PGOS backend Http ticketing algorithm](https://pgos.intlgame.com/pgosdoc/sdk_reference/http_api/integration.html). You can also find the similar implementation in pgos_lib

### Event side

You should configure the event handler in PGOS Console of your title region to connect the specific event with the Virtual Server, then the Virtual Server can be triggerred when the event occurs. [click here](https://pgos.intlgame.com/pgosdoc/manual/service_manual/extensions/event.html) for more information.

## How to deploy the Virtual Server?

step 1: Pack this project into a source code zip file: vs-sample-go.zip

step 2: Create a new Virtual Server in your title region console, and upload the zip file, note the Resource Type shoule be "Source Code with Dockerfile"

step 3: Submit your new Virtual Server and waiting the delpoyment completed.

Now you can access the new Virtual Server once the deployment success.
